<script type="text/javascript">
  (async function() {
    if (!window.dimXmlPromise) {
      const prom = {};
      prom.promise = new Promise((resolve) => (prom.resolve = resolve));
      window.dimXmlPromise = prom;
      /* will be resolved by DimXmlConf script */
    }

    const nodeTemplate = {
      nodeName: {
        property: "name",
        label: RED._('node-red-dim-xml/disXmlCmd:disXmlCmd.label.node-name')
      },
      nodeConf: {
        property: "cnf",
        label: RED._('node-red-dim-xml/disXmlCmd:disXmlCmd.label.node-conf')
      },
      serviceName: {
        property: "serviceName",
        label: RED._('node-red-dim-xml/disXmlCmd:disXmlCmd.label.service-name')
      }
    };

    const disXmlCmdDef = {
      category: 'network',
      color: '#F38B68',
      defaults: {
        name: { value: "" },
        cnf: { type: "dim-xml-conf", required: true },
        serviceName: { value: "", required: true,
          validate: RED.validators.regex(disXml.regExp.srvName)
        }
      },
      icon: 'bridge.svg',
      inputs: 0,
      outputs: 1,
      label: function() {
        return dimXml.utils.getLabel(this, "DIM-XML CMD Server");
      }
    };

    const dimXml = await dimXmlPromise.promise;
    dimXml.utils.genNodeTemplate("dim-xml-cmd-server", nodeTemplate);
    RED.nodes.registerType("dim-xml-cmd-server", disXmlCmdDef);


    /* DIM-XML CMD IN Node */
    /* deep clone of dim-xml-cmd-server node definition */
    disXmlCmdInDef = $.extend(true, {}, disXmlCmdDef);
    disXmlCmdInDef.label = function() {
      return dimXml.utils.getLabel(this, "DIM-XML CMD In");
    };
    dimXml.utils.genNodeTemplate("dim-xml-cmd in", nodeTemplate);
    RED.nodes.registerType("dim-xml-cmd in", disXmlCmdInDef);


    /* DIM-XML CMD RESPONSE Node */
    dimXml.utils.genNodeTemplate("dim-xml-cmd-response", {
      nodeName: { property: "name", label: "Name" }
    });

    RED.nodes.registerType("dim-xml-cmd-response", {
      category: 'network',
      color: '#F38B68',
      defaults: {
        name: { value: "" }
      },
      icon: 'bridge.svg',
      inputs: 1,
      outputs: 0,
      label: function() {
        return dimXml.utils.getLabel(this, "DIM-XML CMD Response");
      }
    });
  }());
</script>

<script type="text/html" data-template-name="dim-xml-cmd-server"></script>

<script type="text/html" data-template-name="dim-xml-cmd in"></script>

<script type="text/html" data-template-name="dim-xml-cmd-response">
  <div class="form-tips"><span data-i18n="[html]disXmlCmd.tip.cmd-response"></span></div>
</script>
